
import numpy.random
import random
import ailib

# opts: [(mu, sig, N, lbl)]
# generate data of the form [([num]#1, lbl)]#N
def gauss_gen(opts, packed=True):
    data = []
    for mu,sig,N,lbl in opts:
        data = data + [([random.gauss(mu, sig)],lbl) for i in range(N)]
    random.shuffle(data)
    
    if not packed: data = ailib.DataFormat.unpack(data)
    return data

# generate gaussian input with multiple input dimensions
# opts: [(mu, sig, N, lbl)], mu: array 1xN, sig: matrix NxN
def gauss_gen_mul(opts, packed=True):
    data = []
    for mu,sig,N,lbl in opts:
        for i in range(N):
            x = numpy.random.multivariate_normal(mu, sig).tolist()
            data.append( (x, lbl) )
    random.shuffle(data)
    
    if not packed: data = ailib.DataFormat.unpack(data)
    return data
